diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/spectrum/model/spectrum-model.cc ns-3.35/src/spectrum/model/spectrum-model.cc
--- ns-3.34/src/spectrum/model/spectrum-model.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/spectrum/model/spectrum-model.cc	2021-10-01 13:26:48.000000000 -0700
@@ -38,7 +38,7 @@
 
 SpectrumModelUid_t SpectrumModel::m_uidCount = 0;
 
-SpectrumModel::SpectrumModel (std::vector<double> centerFreqs)
+SpectrumModel::SpectrumModel (const std::vector<double>& centerFreqs)
 {
   NS_ASSERT (centerFreqs.size () > 1);
   m_uid = ++m_uidCount;
@@ -70,13 +70,20 @@
     }
 }
 
-SpectrumModel::SpectrumModel (Bands bands)
+SpectrumModel::SpectrumModel (const Bands& bands)
 {
   m_uid = ++m_uidCount;
   NS_LOG_INFO ("creating new SpectrumModel, m_uid=" << m_uid);
   m_bands = bands;
 }
 
+SpectrumModel::SpectrumModel (Bands&& bands)
+  : m_bands (std::move (bands))
+{
+  m_uid = ++m_uidCount;
+  NS_LOG_INFO ("creating new SpectrumModel, m_uid=" << m_uid);
+}
+
 Bands::const_iterator
 SpectrumModel::Begin () const
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/spectrum/model/spectrum-model.h ns-3.35/src/spectrum/model/spectrum-model.h
--- ns-3.34/src/spectrum/model/spectrum-model.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/spectrum/model/spectrum-model.h	2021-10-01 13:26:48.000000000 -0700
@@ -82,21 +82,26 @@
    * center frequency of the adjacent lower (resp. upper) band.
    *
    * @param centerFreqs the vector of center frequencies.
-   *
-   * @return
    */
-  SpectrumModel (std::vector<double> centerFreqs);
+  SpectrumModel (const std::vector<double>& centerFreqs);
 
 
   /**
-   * This construct a SpectrumModel based on the explicit values of
+   * This constructs a SpectrumModel based on the explicit values of
    * center frequencies and boundaries of each subband.
    *
-   * @param bands
+   * @param bands the vector of bands for this model
+   */
+  SpectrumModel (const Bands& bands);
+
+  /**
+   * This constructs a SpectrumModel based on the explicit values of
+   * center frequencies and boundaries of each subband. This is used
+   * if <i>bands</i> is an rvalue.
    *
-   * @return
+   * @param bands the vector of bands for this model
    */
-  SpectrumModel (Bands bands);
+  SpectrumModel (Bands&& bands);
 
   /**
    *
@@ -113,10 +118,14 @@
 
   /**
    * Const Iterator to the model Bands container start.
+   *
+   * @return a const iterator to the start of the vector of bands
    */
   Bands::const_iterator Begin () const;
   /**
    * Const Iterator to the model Bands container end.
+   *
+   * @return a const iterator to past-the-end of the vector of bands
    */
   Bands::const_iterator End () const;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/spectrum/model/three-gpp-channel-model.cc ns-3.35/src/spectrum/model/three-gpp-channel-model.cc
--- ns-3.34/src/spectrum/model/three-gpp-channel-model.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/spectrum/model/three-gpp-channel-model.cc	2021-10-01 13:26:48.000000000 -0700
@@ -179,8 +179,12 @@
 void
 ThreeGppChannelModel::DoDispose ()
 {
+  NS_LOG_FUNCTION (this);
   m_channelMap.clear ();
-  m_channelConditionModel->Dispose ();
+  if (m_channelConditionModel)
+    {
+      m_channelConditionModel->Dispose ();
+    }
   m_channelConditionModel = nullptr;
 }
 
@@ -1551,7 +1555,8 @@
 
           for (uint8_t nIndex = 0; nIndex < numReducedCluster; nIndex++)
             {
-              //Compute the N-2 weakest cluster, only vertical polarization. (7.5-22)
+              //Compute the N-2 weakest cluster, assuming 0 slant angle and a
+              //polarization slant angle configured in the array (7.5-22)
               if (nIndex != cluster1st && nIndex != cluster2nd)
                 {
                   std::complex<double> rays (0,0);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/spectrum/model/wifi-spectrum-value-helper.cc ns-3.35/src/spectrum/model/wifi-spectrum-value-helper.cc
--- ns-3.34/src/spectrum/model/wifi-spectrum-value-helper.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/spectrum/model/wifi-spectrum-value-helper.cc	2021-10-01 13:26:48.000000000 -0700
@@ -124,7 +124,7 @@
           NS_LOG_DEBUG ("creating band " << i << " (" << info.fl << ":" << info.fc << ":" << info.fh << ")");
           bands.push_back (info);
         }
-      ret = Create<SpectrumModel> (bands);
+      ret = Create<SpectrumModel> (std::move (bands));
       g_wifiSpectrumModelMap.insert (std::pair<WifiSpectrumModelId, Ptr<SpectrumModel> > (key, ret));
     }
   NS_LOG_LOGIC ("returning SpectrumModel::GetUid () == " << ret->GetUid ());
@@ -640,6 +640,21 @@
   return std::pow (10.0, 0.1 * (dBm - 30.0));
 }
 
+double
+WifiSpectrumValueHelper::GetBandPowerW (Ptr<SpectrumValue> psd, const WifiSpectrumBand &band)
+{
+    double powerWattPerHertz = 0.0;
+    auto valueIt = psd->ConstValuesBegin() + band.first;
+    auto end = psd->ConstValuesBegin() + band.second;
+    auto bandIt = psd->ConstBandsBegin() + band.first;
+    while (valueIt <= end)
+    {
+        powerWattPerHertz += *valueIt;
+        ++valueIt;
+    }
+    return powerWattPerHertz * (bandIt->fh - bandIt->fl);
+}
+
 static Ptr<SpectrumModel> g_WifiSpectrumModel5Mhz; ///< static initializer for the class
 
 WifiSpectrumValueHelper::~WifiSpectrumValueHelper ()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/spectrum/model/wifi-spectrum-value-helper.h ns-3.35/src/spectrum/model/wifi-spectrum-value-helper.h
--- ns-3.34/src/spectrum/model/wifi-spectrum-value-helper.h	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/spectrum/model/wifi-spectrum-value-helper.h	2021-10-01 13:26:48.000000000 -0700
@@ -215,7 +215,6 @@
    * \param minInnerBandDbr the minimum relative power in the inner band (i.e. -20 dBr in the figure above)
    * \param minOuterbandDbr the minimum relative power in the outer band (i.e. -28 dBr in the figure above)
    * \param lowestPointDbr maximum relative power of the outermost subcarriers of the guard band (in dBr)
-   * \return a pointer to a newly allocated SpectrumValue representing the HT OFDM Transmit Power Spectral Density in W/Hz for each Band
    */
   static void CreateSpectrumMaskForOfdm (Ptr<SpectrumValue> c, std::vector <WifiSpectrumBand> allocatedSubBands, WifiSpectrumBand maskBand,
                                          double txPowerPerBandW, uint32_t nGuardBands, uint32_t innerSlopeWidth,
@@ -240,6 +239,16 @@
    * \return the equivalent Watts for the given dBm
    */
   static double DbmToW (double dbm);
+
+  /**
+   * Calculate the power of the specified band composed of uniformly-sized sub-bands.
+   *
+   * \param psd received Power Spectral Density in W/Hz
+   * \param band a pair of start and stop indexes that defines the band
+   *
+   * \return band power in W
+   */
+  static double GetBandPowerW (Ptr<SpectrumValue> psd, const WifiSpectrumBand &band);
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/tap-bridge/bindings/modulegen__gcc_ILP32.py ns-3.35/src/tap-bridge/bindings/modulegen__gcc_ILP32.py
--- ns-3.34/src/tap-bridge/bindings/modulegen__gcc_ILP32.py	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/tap-bridge/bindings/modulegen__gcc_ILP32.py	2021-10-01 13:26:48.000000000 -0700
@@ -1341,11 +1341,6 @@
                    'bool', 
                    [], 
                    is_const=True)
-    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsEqual(ns3::Ipv4Address const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv4Address const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsInitialized() const [member function]
     cls.add_method('IsInitialized', 
                    'bool', 
@@ -1450,11 +1445,6 @@
                    'ns3::Ipv4Mask', 
                    [], 
                    is_static=True)
-    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsEqual(ns3::Ipv4Mask other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv4Mask', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsMatch(ns3::Ipv4Address a, ns3::Ipv4Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
@@ -1571,11 +1561,6 @@
                    'bool', 
                    [], 
                    is_const=True)
-    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsEqual(ns3::Ipv6Address const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv6Address const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsInitialized() const [member function]
     cls.add_method('IsInitialized', 
                    'bool', 
@@ -1768,11 +1753,6 @@
                    'ns3::Ipv6Prefix', 
                    [], 
                    is_static=True)
-    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsEqual(ns3::Ipv6Prefix const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv6Prefix const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsMatch(ns3::Ipv6Address a, ns3::Ipv6Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/tap-bridge/bindings/modulegen__gcc_LP64.py ns-3.35/src/tap-bridge/bindings/modulegen__gcc_LP64.py
--- ns-3.34/src/tap-bridge/bindings/modulegen__gcc_LP64.py	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/tap-bridge/bindings/modulegen__gcc_LP64.py	2021-10-01 13:26:48.000000000 -0700
@@ -1341,11 +1341,6 @@
                    'bool', 
                    [], 
                    is_const=True)
-    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsEqual(ns3::Ipv4Address const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv4Address const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsInitialized() const [member function]
     cls.add_method('IsInitialized', 
                    'bool', 
@@ -1450,11 +1445,6 @@
                    'ns3::Ipv4Mask', 
                    [], 
                    is_static=True)
-    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsEqual(ns3::Ipv4Mask other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv4Mask', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsMatch(ns3::Ipv4Address a, ns3::Ipv4Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
@@ -1571,11 +1561,6 @@
                    'bool', 
                    [], 
                    is_const=True)
-    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsEqual(ns3::Ipv6Address const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv6Address const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsInitialized() const [member function]
     cls.add_method('IsInitialized', 
                    'bool', 
@@ -1768,11 +1753,6 @@
                    'ns3::Ipv6Prefix', 
                    [], 
                    is_static=True)
-    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsEqual(ns3::Ipv6Prefix const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv6Prefix const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsMatch(ns3::Ipv6Address a, ns3::Ipv6Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/topology-read/bindings/modulegen__gcc_ILP32.py ns-3.35/src/topology-read/bindings/modulegen__gcc_ILP32.py
--- ns-3.34/src/topology-read/bindings/modulegen__gcc_ILP32.py	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/topology-read/bindings/modulegen__gcc_ILP32.py	2021-10-01 13:26:48.000000000 -0700
@@ -1124,11 +1124,6 @@
                    'bool', 
                    [], 
                    is_const=True)
-    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsEqual(ns3::Ipv4Address const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv4Address const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsInitialized() const [member function]
     cls.add_method('IsInitialized', 
                    'bool', 
@@ -1233,11 +1228,6 @@
                    'ns3::Ipv4Mask', 
                    [], 
                    is_static=True)
-    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsEqual(ns3::Ipv4Mask other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv4Mask', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsMatch(ns3::Ipv4Address a, ns3::Ipv4Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
@@ -1354,11 +1344,6 @@
                    'bool', 
                    [], 
                    is_const=True)
-    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsEqual(ns3::Ipv6Address const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv6Address const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsInitialized() const [member function]
     cls.add_method('IsInitialized', 
                    'bool', 
@@ -1551,11 +1536,6 @@
                    'ns3::Ipv6Prefix', 
                    [], 
                    is_static=True)
-    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsEqual(ns3::Ipv6Prefix const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv6Prefix const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsMatch(ns3::Ipv6Address a, ns3::Ipv6Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/topology-read/bindings/modulegen__gcc_LP64.py ns-3.35/src/topology-read/bindings/modulegen__gcc_LP64.py
--- ns-3.34/src/topology-read/bindings/modulegen__gcc_LP64.py	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/topology-read/bindings/modulegen__gcc_LP64.py	2021-10-01 13:26:48.000000000 -0700
@@ -1124,11 +1124,6 @@
                    'bool', 
                    [], 
                    is_const=True)
-    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsEqual(ns3::Ipv4Address const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv4Address const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsInitialized() const [member function]
     cls.add_method('IsInitialized', 
                    'bool', 
@@ -1233,11 +1228,6 @@
                    'ns3::Ipv4Mask', 
                    [], 
                    is_static=True)
-    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsEqual(ns3::Ipv4Mask other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv4Mask', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsMatch(ns3::Ipv4Address a, ns3::Ipv4Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
@@ -1354,11 +1344,6 @@
                    'bool', 
                    [], 
                    is_const=True)
-    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsEqual(ns3::Ipv6Address const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv6Address const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsInitialized() const [member function]
     cls.add_method('IsInitialized', 
                    'bool', 
@@ -1551,11 +1536,6 @@
                    'ns3::Ipv6Prefix', 
                    [], 
                    is_static=True)
-    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsEqual(ns3::Ipv6Prefix const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv6Prefix const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsMatch(ns3::Ipv6Address a, ns3::Ipv6Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/topology-read/examples/topology-example-sim.cc ns-3.35/src/topology-read/examples/topology-example-sim.cc
--- ns-3.34/src/topology-read/examples/topology-example-sim.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/topology-read/examples/topology-example-sim.cc	2021-10-01 13:26:48.000000000 -0700
@@ -31,7 +31,7 @@
 #include "ns3/internet-module.h"
 #include "ns3/point-to-point-module.h"
 #include "ns3/applications-module.h"
-#include "ns3/ipv4-nix-vector-helper.h"
+#include "ns3/nix-vector-helper.h"
 
 #include "ns3/topology-read-module.h"
 #include <list>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/traffic-control/bindings/modulegen__gcc_ILP32.py ns-3.35/src/traffic-control/bindings/modulegen__gcc_ILP32.py
--- ns-3.34/src/traffic-control/bindings/modulegen__gcc_ILP32.py	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/traffic-control/bindings/modulegen__gcc_ILP32.py	2021-10-01 13:26:48.000000000 -0700
@@ -1692,11 +1692,6 @@
                    'bool', 
                    [], 
                    is_const=True)
-    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsEqual(ns3::Ipv4Address const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv4Address const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsInitialized() const [member function]
     cls.add_method('IsInitialized', 
                    'bool', 
@@ -1801,11 +1796,6 @@
                    'ns3::Ipv4Mask', 
                    [], 
                    is_static=True)
-    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsEqual(ns3::Ipv4Mask other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv4Mask', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsMatch(ns3::Ipv4Address a, ns3::Ipv4Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
@@ -1922,11 +1912,6 @@
                    'bool', 
                    [], 
                    is_const=True)
-    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsEqual(ns3::Ipv6Address const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv6Address const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsInitialized() const [member function]
     cls.add_method('IsInitialized', 
                    'bool', 
@@ -2119,11 +2104,6 @@
                    'ns3::Ipv6Prefix', 
                    [], 
                    is_static=True)
-    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsEqual(ns3::Ipv6Prefix const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv6Prefix const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsMatch(ns3::Ipv6Address a, ns3::Ipv6Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/traffic-control/bindings/modulegen__gcc_LP64.py ns-3.35/src/traffic-control/bindings/modulegen__gcc_LP64.py
--- ns-3.34/src/traffic-control/bindings/modulegen__gcc_LP64.py	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/traffic-control/bindings/modulegen__gcc_LP64.py	2021-10-01 13:26:48.000000000 -0700
@@ -1692,11 +1692,6 @@
                    'bool', 
                    [], 
                    is_const=True)
-    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsEqual(ns3::Ipv4Address const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv4Address const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsInitialized() const [member function]
     cls.add_method('IsInitialized', 
                    'bool', 
@@ -1801,11 +1796,6 @@
                    'ns3::Ipv4Mask', 
                    [], 
                    is_static=True)
-    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsEqual(ns3::Ipv4Mask other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv4Mask', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsMatch(ns3::Ipv4Address a, ns3::Ipv4Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
@@ -1922,11 +1912,6 @@
                    'bool', 
                    [], 
                    is_const=True)
-    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsEqual(ns3::Ipv6Address const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv6Address const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsInitialized() const [member function]
     cls.add_method('IsInitialized', 
                    'bool', 
@@ -2119,11 +2104,6 @@
                    'ns3::Ipv6Prefix', 
                    [], 
                    is_static=True)
-    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsEqual(ns3::Ipv6Prefix const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv6Prefix const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsMatch(ns3::Ipv6Address a, ns3::Ipv6Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/traffic-control/model/fq-pie-queue-disc.cc ns-3.35/src/traffic-control/model/fq-pie-queue-disc.cc
--- ns-3.34/src/traffic-control/model/fq-pie-queue-disc.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/traffic-control/model/fq-pie-queue-disc.cc	2021-10-01 13:26:48.000000000 -0700
@@ -512,17 +512,17 @@
 
   m_queueDiscFactory.SetTypeId ("ns3::PieQueueDisc");
   m_queueDiscFactory.Set ("MaxSize", QueueSizeValue (GetMaxSize ()));
-  m_queueDiscFactory.Set ("MeanPktSize", UintegerValue (1000));
-  m_queueDiscFactory.Set ("A", DoubleValue (0.125));
-  m_queueDiscFactory.Set ("B", DoubleValue (1.25));
-  m_queueDiscFactory.Set ("Tupdate", TimeValue (Seconds (0.015)));
-  m_queueDiscFactory.Set ("Supdate", TimeValue (Seconds (0)));
-  m_queueDiscFactory.Set ("DequeueThreshold", UintegerValue (16384));
-  m_queueDiscFactory.Set ("QueueDelayReference", TimeValue (Seconds (0.015)));
-  m_queueDiscFactory.Set ("MaxBurstAllowance", TimeValue (Seconds (0.15)));
-  m_queueDiscFactory.Set ("UseDequeueRateEstimator", BooleanValue (false));
-  m_queueDiscFactory.Set ("UseCapDropAdjustment", BooleanValue (true));
-  m_queueDiscFactory.Set ("UseDerandomization", BooleanValue (false));
+  m_queueDiscFactory.Set ("MeanPktSize", UintegerValue(m_meanPktSize));
+  m_queueDiscFactory.Set ("A", DoubleValue (m_a));
+  m_queueDiscFactory.Set ("B", DoubleValue (m_b));
+  m_queueDiscFactory.Set ("Tupdate", TimeValue (m_tUpdate));
+  m_queueDiscFactory.Set ("Supdate", TimeValue (m_sUpdate));
+  m_queueDiscFactory.Set ("DequeueThreshold", UintegerValue (m_dqThreshold));
+  m_queueDiscFactory.Set ("QueueDelayReference", TimeValue (m_qDelayRef));
+  m_queueDiscFactory.Set ("MaxBurstAllowance", TimeValue (m_maxBurst));
+  m_queueDiscFactory.Set ("UseDequeueRateEstimator", BooleanValue (m_useDqRateEstimator));
+  m_queueDiscFactory.Set ("UseCapDropAdjustment", BooleanValue (m_isCapDropAdjustment));
+  m_queueDiscFactory.Set ("UseDerandomization", BooleanValue (m_useDerandomization));
 }
 
 uint32_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/traffic-control/model/tbf-queue-disc.cc ns-3.35/src/traffic-control/model/tbf-queue-disc.cc
--- ns-3.34/src/traffic-control/model/tbf-queue-disc.cc	2021-07-14 10:31:07.000000000 -0700
+++ ns-3.35/src/traffic-control/model/tbf-queue-disc.cc	2021-10-01 13:26:48.000000000 -0700
@@ -254,16 +254,38 @@
         }
 
       // the watchdog timer setup.
-      /* A packet gets blocked if the above if condition is not satisfied, i.e.
-      both the ptoks and btoks are less than zero. In that case we have to 
-      schedule the waking of queue when enough tokens are available. */
+      // A packet gets blocked if the above if() condition is not satisfied:
+      // either or both btoks and ptoks are negative.  In that case, we have
+      // to schedule the waking of queue when enough tokens are available.
       if (m_id.IsExpired () == true)
         {
-          Time requiredDelayTime = std::max (m_rate.CalculateBytesTxTime (-btoks),
-                                             m_peakRate.CalculateBytesTxTime (-ptoks));
+          NS_ASSERT_MSG (m_rate.GetBitRate () > 0, "Rate must be positive");
+          Time requiredDelayTime;
+          if (m_peakRate.GetBitRate () == 0)
+            {
+              NS_ASSERT_MSG (btoks < 0, "Logic error; btoks must be < 0 here");
+              requiredDelayTime = m_rate.CalculateBytesTxTime (-btoks);
+            }
+          else
+            {
+              if (btoks < 0 && ptoks >= 0)
+                {
+                  requiredDelayTime = m_rate.CalculateBytesTxTime (-btoks);
+                }
+              else if (btoks >= 0 && ptoks < 0)
+                {
+                  requiredDelayTime = m_peakRate.CalculateBytesTxTime (-ptoks);
+                }
+              else
+                {
+                  requiredDelayTime = std::max (m_rate.CalculateBytesTxTime (-btoks),
+                                                m_peakRate.CalculateBytesTxTime (-ptoks));
+                }
 
+            }
+          NS_ASSERT_MSG (requiredDelayTime.GetSeconds () >= 0, "Negative time");
           m_id = Simulator::Schedule (requiredDelayTime, &QueueDisc::Run, this);
-          NS_LOG_LOGIC("Waking Event Scheduled in " << requiredDelayTime);
+          NS_LOG_LOGIC("Waking Event Scheduled in " << requiredDelayTime.As (Time::S));
         }
     }
   return 0;
